/*
 * Copyright (C) 2020-2021 Aloysius Indrayanto
 *
 * This file is part of the eCxx library, see LICENSE file for the license details.
 */


#include <eCxx/eCxx_SPILEDDriver1DShortcut.h>

#include "NodeMCU_Common.h"


//
// Pin numbers
//
static constexpr eCxx::uint8_t PIN_DATA  = 0;
static constexpr eCxx::uint8_t PIN_CLOCK = 2;


//
// Include common source code for 1-dimensional animation using APA102C LED strip test application
//
#include "../CommonCode/Anim1DAPA102C_Common.h"


//
// The init function
//
void eCxx_user_init()
{
    // Initialize application
    initBasicNodeMCUApp();

    // Enable the 74LVC541 buffers on the eCxx NodeMCU development board because
    // the pins defined above are buffered
    App::setPinMode  ( eCxx::NodeMCU::D0, eCxx::Application::PinMode::Output ); // GPIO16
    App::digitalWrite( eCxx::NodeMCU::D0, false                              ); // The buffers are active low

    // Initialize the animation and driver
    eCxx_user_init_initializeAnimationAndDriver();
}


//
// The task function
//
void eCxx_user_task()
{
    // Process event and update the LED strip animation
    eCxx_user_task_updateAnimation();
}
